//Script for lesser enemies

#import "data/scripts/library/spawn.h"
#import "data/scripts/library/basic.h"
#import "data/scripts/library/enemies.h"

void layer(int layer)
{// Set's enemy's layer
    void self = getlocalvar("self");
    changeentityproperty(self, "setlayer", layer);
}

void givescore(int Add)
{// Gives score to players
    void P1 = getplayerproperty(0, "entity");

    if(P1!=NULL()){
      int P1Score = getplayerproperty(0, "score");
      changeplayerproperty(0, "score", P1Score+Add);
    }
}

void spawnM(void Name, float dx, float dy, float dz)
{ // Spawn certain entity and matches its map with own's map
   void self = getlocalvar("self");
   int map = getentityproperty(self,"map");
   void Spawn;

   Spawn = spawn01(Name, dx, dy, 0);
   changeentityproperty(Spawn, "map", map);
}

void spawnEnt(void Name, float dx, float dy, float dz, int Num)
{ // Spawn other entity with same map & store it
   void self = getlocalvar("self");
   int map = getentityproperty(self,"map");
   void Spawn;

   Spawn = spawn01(Name, dx, dy, dz);
   changeentityproperty(Spawn, "map", map);
   setentityvar(self, Num, Spawn); // Stores spawned gun to be ordered later
}

void aniSlave(int Num, void Ani)
{// Animation changer for slaves
    void self = getlocalvar("self");
    void Gun = getentityvar(self, Num);

    if(Gun){
      performattack(Gun, openborconstant(Ani));
    }
}

void shadow(int max, int delay, int timeout, int alpha, int tintm, int r, int g, int b)
{//animation script for shadow trails by msmalik681
	void self = getlocalvar("self"); //Get calling entity.
	int anim = getentityproperty(self, "animationid");//Get calling animation id.
	//if any values null set defaults
	if(max==NULL()){max=5;}
	if(delay==NULL()){delay=20;}
	if(timeout==NULL()){timeout=90;}
	if(alpha==NULL()){alpha=6;}
	if(tintm==NULL()){tintm=2;}
	if(r==NULL()){r=0;}
	if(g==NULL()){g=0;}
	if(b==NULL()){b=255;}
	//store all recorded data into entity variables.
	setentityvar(self,"shadow.anim", anim);
	setentityvar(self,"shadow.max", max);
	setentityvar(self,"shadow.delay", delay);
	setentityvar(self,"shadow.timeout", timeout);
	setentityvar(self,"shadow.alpha", alpha);
	setentityvar(self,"shadow.tintm", tintm);
	setentityvar(self,"shadow.r", r);
	setentityvar(self,"shadow.g", g);
	setentityvar(self,"shadow.b", b);
	}

void dasher( float Vx, float Vy, float Vz , int Flip)
{// Dash with desired speed!
// Won't apply if enemy is in midair
    void self = getlocalvar("self");
    int dir = getentityproperty(self,"direction");
    int y = getentityproperty(self, "a");
    int b = getentityproperty(self, "base");

    if(dir==0 && Flip==1){ // Facing left?
      Vx = -Vx ;
    }

    if(y <= b){
      changeentityproperty(self, "velocity", Vx, Vz, Vy); //Move!
    }
}

void spawnToss(void name, float dx, float dy, float dz, float Vx, float Vy, float Vz, void ani, int atk, int setMap)
{//Spawn and Toss entity with defined conditions (DEFAULT TOSS SCRIPT USED FOR ALL SPAWNED ENTITIES, LIKE ITENS)
	void self 		= getlocalvar("self");
	void type		= getentityproperty(self, "type");
	void hostile	= getentityproperty(self, "hostile");
	void candamage	= getentityproperty(self, "candamage");
	void vSpawn 	= spawn01(name, dx, dy, dz);
	int direction 	= getentityproperty(self, "direction");
	int map 		= getentityproperty(self, "map");

	if(direction == 0){
		Vx = -Vx;//Change direction to match facing
	}
	
	tossentity(vSpawn, Vy, Vx, Vz); //Toss entity with defined speed
	
	if(ani != NULL()){ //Spawn with a specific animation??
		changeentityproperty(vSpawn, "animation", openborconstant(ani));
	}
	
	if(atk != NULL()){ //This entity is used for attacks??
		void vAniID = getentityproperty(self, "animationID");
		int disable	= getentityproperty(self, "energycost", "disable", openborconstant(vAniID));
		
		changeentityproperty(vSpawn, "parent", self);
		changeentityproperty(vSpawn, "owner", self);
		changeentityproperty(vSpawn, "hostile", hostile);
		changeentityproperty(vSpawn, "candamage", candamage);
		setglobalvar("projectile"+self, vSpawn);
		setentityvar(vSpawn, "disable", disable);
		
		if(type == openborconstant("TYPE_ENEMY")){ //Is entity a enemy type?
			changeentityproperty(vSpawn, "type", openborconstant("TYPE_SHOT"));
		}
	}

	if(setMap != NULL()){
		changeentityproperty(vSpawn, "map", map);
	}
}

void shooter2(void vName, float fX, float fY, float fZ, float Vx, float Vy, float Vz)
{//Spawns projectile next to caller
 //vName: Model name of entity to be spawned in
 //fX: X location adjustment
 //fZ: Y location adjustment
 //fY: Z location adjustment
 //Vx: X speed
 //Vy: Y speed
 //Vz: Z speed

   void self = getlocalvar("self"); //Get calling entity
   int Direction = getentityproperty(self, "direction");
   void vSpawn; //Spawn object.
	
   vSpawn = spawn01(vName, fX, fY, fZ); //Spawn in projectile
   if (Direction == 0){ //Is entity facing left?                 
      Vx = -Vx; //Reverse Vx direction to match facing
   }

   changeentityproperty(vSpawn, "velocity", Vx, Vz, Vy);
    return vSpawn;
}

void Shadremen()
{// Increment shadow counter
    void S = getglobalvar("H1G3");

    setglobalvar("H1G3", S+1);

    if(S >= 99){
      spawnXT("trophy_100", 160, 0, 100, "PeHun", 728);
    }
}

void Obremen()
{// Increment obstacles counter
    void S = getglobalvar("CoH1");

    setglobalvar("CoH1", S+1);

    if(S >= 9){
      spawnXT("trophy_obstacle", 160, 0, 100, "Xobc", 374);
    }
}